﻿#region Copyright Syncfusion Inc. 2001 - 2012
//
//  Copyright Syncfusion Inc. 2001 - 2012. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.DocIO.DLS;
using Syncfusion.DocIO;
using System.ComponentModel;

namespace GenerateWord
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        # region Constructor
        /// <summary>
        /// Window constructor
        /// </summary>
        public Window1()
        {
            InitializeComponent();
            ImageSourceConverter img = new ImageSourceConverter();
            image1.Source = (ImageSource)img.ConvertFromString(@"..\..\Images\docio_header.png");
            imgbutton.Source = (ImageSource)img.ConvertFromString(@"..\..\Images\docio_button.png");            
            imglabel.Source = (ImageSource)img.ConvertFromString(@"..\..\Images\label8_Image.gif");
            imglabel1.Source = (ImageSource)img.ConvertFromString(@"..\..\Images\label8_Image.gif");
            imglabel2.Source = (ImageSource)img.ConvertFromString(@"..\..\Images\label8_Image.gif");
            imglabel3.Source = (ImageSource)img.ConvertFromString(@"..\..\Images\label8_Image.gif");
            this.Icon =(ImageSource)img.ConvertFromString(@"..\..\Images\docio_button.png");            
        }
        # endregion

        # region Events
        /// <summary>
        /// Creates word document
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //Getting Image files path.
            string dataPath = @"..\..\Data\";
            //Field need to update in the text
            string updateField = "PersonName";
            //A Open a Word document 
            WordDocument document = new WordDocument(dataPath+"Template.docx");
           //Iterate the document section in the Word document field 
            foreach (WSection section in document.Sections)
            {
                //Iterate the Form fields in the section Body form fields
                foreach (WFormField formfield in section.Body.FormFields)
                {
                    //Find and check the Form field to update
                    if (formfield is WTextFormField && (formfield as WTextFormField).Name == updateField)
                    {
                        //Update the field value
                        WTextFormField textFormField = formfield as WTextFormField;
                        textFormField.Text = "Peter";
                        Entity entity = textFormField as Entity;
                        //Set the Hidden property to all the TextFormField Structure
                        while (entity.NextSibling != null)
                        {
                            switch (entity.EntityType)
                            {
                                case EntityType.FieldMark:
                                    (entity as WFieldMark).CharacterFormat.Hidden = true;
                                    break;
                                case EntityType.TextRange:
                                    (entity as WTextRange).CharacterFormat.Hidden = true;
                                    break;
                            }
                            entity = entity.NextSibling as Entity;
                        }
                    }
                }
            }
           
            //Save as word 2003  format
            if (word2003RadioBtn.IsChecked.Value)
            {
                //Saving the document to disk.
                document.Save("Sample.doc");

                //Message box confirmation to view the created document.
                if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButton.YesNo, MessageBoxImage.Information) == MessageBoxResult.Yes)
                {
                    //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                    System.Diagnostics.Process.Start("Sample.doc");
                    //Exit
                    this.Close();
                }
            }
            //Save as word 2007 format
            else if (word2007RadioBtn.IsChecked.Value)
            {
                //Saving the document as .docx
                document.Save("Sample.docx", FormatType.Word2007);
                //Message box confirmation to view the created document.
                if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButton.YesNo, MessageBoxImage.Information) == MessageBoxResult.Yes)
                {
                    try
                    {
                        //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                        System.Diagnostics.Process.Start("Sample.docx");
                        //Exit
                        this.Close();
                    }
                    catch (Win32Exception ex)
                    {
                        MessageBox.Show("Word 2007 is not installed in this system");
                        Console.WriteLine(ex.ToString());
                    }
                }
            }
            //Save as word 2010 format
            else if (word2010RadioBtn.IsChecked.Value)
            {
                //Saving the document as .docx
                document.Save("Sample.docx", FormatType.Word2010);
                //Message box confirmation to view the created document.
                if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButton.YesNo, MessageBoxImage.Information) == MessageBoxResult.Yes)
                {
                    try
                    {
                        //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                        System.Diagnostics.Process.Start("Sample.docx");
                        //Exit
                        this.Close();
                    }
                    catch (Win32Exception ex)
                    {
                        MessageBox.Show("Word 2007 is not installed in this system");
                        Console.WriteLine(ex.ToString());
                    }
                }
            }
            //Save as word 2013  format
            else if (word2013RadioBtn.IsChecked.Value)
            {
                //Saving the document as .docx
                document.Save("Sample.docx", FormatType.Word2013);
                //Message box confirmation to view the created document.
                if (MessageBox.Show("Do you want to view the MS Word document?", "Document has been created", MessageBoxButton.YesNo, MessageBoxImage.Information) == MessageBoxResult.Yes)
                {
                    try
                    {
                        //Launching the MS Word file using the default Application.[MS Word Or Free WordViewer]
                        System.Diagnostics.Process.Start("Sample.docx");
                        //Exit
                        this.Close();
                    }
                    catch (Win32Exception ex)
                    {
                        MessageBox.Show("Word 2013 is not installed in this system");
                        Console.WriteLine(ex.ToString());
                    }
                }
            }
            else
            {
                // Exit
                this.Close();
            }
        }
        # endregion
    }
}